#!/bin/sh

INSTDIR=$1
USERINST=$2
MODDIR=/lib/modules/`uname -r`
DISTDIR=`uname -r | sed -e's/-.*$//g'`

NCPUS=`grep processor /proc/cpuinfo | wc -l`

if [ $NCPUS -gt 1 ]; then
	DISTDIR="$DISTDIR"smp
fi
	
if [ ! -d $DISTDIR ]; then
    echo "The modules matching the installalled OS version $DISTDIR"
    echo "Could not be found.  The  version closest to your"
    echo "installed version may work."
    echo "cp <closest match>/plconf /sbin"
    echo "cp <closest match>/*.o $MODDIR"
    echo "You may need to use insmod -f to get the modules to load."
    echo "This script will now install the non OS dependent files."
fi

if [ ! -d $MODDIR ]; then
    if [ -z "$USERINST" ] && [ -d /lib/modules/preferred ]; then
	echo "Cannot find $MODDIR... Using /lib/modules/preferred"
	MODDIR=/lib/modules/preferred
    fi
fi
    
if [ ! -z "$INSTDIR" ]; then
	cd $INSTDIR
elif [ -f plink_config ] && [ -f plconf ]; then
	INSTDIR=`pwd`
elif [ -d /mnt/cdrom/phobos/Linux ]; then
	INSTDIR="/mnt/cdrom/phobos/Linux"
	cd $INSTDIR
else
	echo "Usage: install_phoboslink <installation_directory> [module_directory]"
	echo "Could not find the PhobosLink files!"
	echo "Please check the installation directory.  This scripts checks"
	echo "the current directory and \"/mnt/cdrom/phobos/Linux\" for the"
	echo "installation files."
	exit 1
fi

cwd=`pwd`


if [ -f plconf ] && [ -f phoboslink ] && [ -f plink_config ]; then
	# copy in the PhobosLink startup files
	cp plconf /sbin/plconf
	echo 'installing /sbin/plconf'
	cp phoboslink /etc/rc.d/init.d/phoboslink
	echo 'installing /etc/rc.d/init.d/phoboslink' 
	cp plink_config /usr/bin/plink_config
	echo 'installing /usr/bin/plink_config'

# Make sure that PhobosLink has started before we try to configure 
# the interfaces associated with it.  In RedHat the network starts
# with rc2.d/S10network

	chkconfig --add phoboslink
	echo 'activating phoboslink startup script'	
else
	echo "Could not find the PhobosLink files!!"
	echo "Please check the installation directory"
	echo "Usage: install_phoboslink <installation_directory> [module_directory]"
	exit 1
fi
		
# let's copy in the proper control files without the annoying file not found message
# for the files *_control and *Control files not with distribution.
if [ -f pqfe_control ] && [ -f PQFEControl ]; then
	cp -f pqfe_control PQFEControl /usr/bin
	echo "installing /usr/bin/pqfe_control /usr/bin/PQFEControl"
elif [ -f pfx_control ] && [ -f PFXControl ]; then
	cp -f pfx_control PFXControl /usr/bin
	echo "installing /usr/bin/pfx /usr/bin/PFXControl"
elif [ -f pfe_control ] && [ -f PFEControl ]; then
	cp -f pfe_control PFEControl /usr/bin
	echo "installing /usr/bin/pfe_control /usr/bin/PFEControl"
else
	echo "Could not find the proper control files for your Phobos adapter."
	echo "Check your distribution for the proper files.  They should be the"
	echo "file pair of:"
	echo "	\"pqfe_control\" and \"PQFEControl\" for the P430"
	echo "	\"pfx_control\" and \"PFXControl\" for the P100FX"
	echo "	\"pfe_control\" and \"PFEControl\" for the P100TX"
	echo "These files should be copied to your \"/usr/bin\""
	echo "directory."
fi


FOUND=""
SMP="NOSMP"
		
if [ -d $DISTDIR ] && [ ! -z "$MODDIR" ]  && [ -d "$MODDIR" ]; then
	echo "installing driver modules"
	cp $DISTDIR/plink.o $MODDIR/net/plink.o
	echo "	$MODDIR/net/plink.o"
	cp $DISTDIR/phobos.o $MODDIR/net/phobos.o
	echo "	$MODDIR/net/phobos.o"
	MODDIR=""
	DIRS=""
	FOUND="TRUE"
fi
		
if [ -z $FOUND ]; then
	echo "We did not find a modules directory!!"
	echo "You need to copy the \"phobos.o\" and \"plink.o\" files into your"
	echo "appropriate modules directory."
	echo "The appropriate initialization startup scripts have been installed into the"
	echo "current \"etc/rc.d/init.d\", \"/sbin\" and \"/usr/bin\" directorys.  Should"
	echo "you have a different disk or partition for your module you will also"
	echo "need to copy the \"plconf\" file to \"/sbin\", \"phoboslink\" to the init.d"
	echo "directory and \"pqfe_control\" and \"PQFEControl\" to \"/usr/bin\"."
	echo "A symbolic link is also necessary in in \"/etc/rc.d/rc2.d/\" to"
	echo "\"/etc/rc.d/init.d/phoboslink\" to start PhobosLink BEFORE trying to configure"
	echo "the plink\# interfaces.  We use \"S9phoboslink\"."
fi
